/*
 * MIGETCOL.H -- LIBMI accessors for columns of system tables
 *
 *     Copyright c 1995 Illustra Information Technologies, Inc.
 *     All rights reserved.      See files/copyright.
 *
 */
 
#ifndef _MIGETCOL_H_
#define _MIGETCOL_H_


/* in-memory representation of a row in the 'am' table */
typedef struct mi_AmRow_s AmRow;
typedef AmRow  mi_am_row;

/* accessor functions for mi_am_row */

EXTERNC_BEGIN
mi_oid  * MI_PROC_EXPORT mi_get_am_owner ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_schema ARGS((mi_am_row *row));
mi_char1   MI_PROC_EXPORT mi_get_am_kind ARGS((mi_am_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_am_strategies ARGS((mi_am_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_am_support ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_gettuplefunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_insertfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_deletefunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_beginscanfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_rescanfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_endscanfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_markposfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_restrposfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_openfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_closefunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_buildfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_createfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_destroyfunc ARGS((mi_am_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_am_name ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_getbyidfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_vacuumfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_costfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_updatefunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_checkfunc ARGS((mi_am_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_am_rowidtype ARGS((mi_am_row *row));
EXTERNC_END


/* in-memory representation of a row in the 'tables' table */
typedef struct mi_TableRow_s TableRow;
typedef TableRow mi_table_row;

/* accessor functions for mi_table_row */

EXTERNC_BEGIN
mi_oid  * MI_PROC_EXPORT mi_get_tab_owner ARGS((mi_table_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_tab_schema ARGS((mi_table_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_tab_am ARGS((mi_table_row *row));
mi_integer   MI_PROC_EXPORT mi_get_tab_pages ARGS((mi_table_row *row));
mi_integer   MI_PROC_EXPORT mi_get_tab_rows ARGS((mi_table_row *row));
mi_abstime  * MI_PROC_EXPORT mi_get_tab_expires ARGS((mi_table_row *row));
mi_abstime  * MI_PROC_EXPORT mi_get_tab_preserved ARGS((mi_table_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_tab_issystem ARGS((mi_table_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_tab_hasindex ARGS((mi_table_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_tab_isshared ARGS((mi_table_row *row));
mi_char1   MI_PROC_EXPORT mi_get_tab_kind ARGS((mi_table_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_tab_arch ARGS((mi_table_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_tab_info ARGS((mi_table_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_tab_columns ARGS((mi_table_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_tab_smgr ARGS((mi_table_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_tab_type ARGS((mi_table_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_tab_name ARGS((mi_table_row *row));
mi_varlena  * MI_PROC_EXPORT mi_get_tab_unique ARGS((mi_table_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_tab_amdata ARGS((mi_table_row *row));
EXTERNC_END


/* in-memory representation of a row in the 'columns' table */
typedef struct mi_ColumnRow_s ColumnRow;
typedef ColumnRow mi_column_row;

/* accessor functions for mi_column_row */

EXTERNC_BEGIN
mi_oid  * MI_PROC_EXPORT mi_get_col_member ARGS((mi_column_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_col_type ARGS((mi_column_row *row));
mi_integer   MI_PROC_EXPORT mi_get_col_bound ARGS((mi_column_row *row));
mi_integer   MI_PROC_EXPORT mi_get_col_parameter ARGS((mi_column_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_col_number ARGS((mi_column_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_col_length ARGS((mi_column_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_col_byvalue ARGS((mi_column_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_col_canindex ARGS((mi_column_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_col_notnull ARGS((mi_column_row *row));
mi_int1   MI_PROC_EXPORT mi_get_col_hasdefault ARGS((mi_column_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_col_isvirtual ARGS((mi_column_row *row));
mi_char1   MI_PROC_EXPORT mi_get_col_class ARGS((mi_column_row *row));
mi_int1   MI_PROC_EXPORT mi_get_col_key ARGS((mi_column_row *row));
mi_int1   MI_PROC_EXPORT mi_get_col_mode ARGS((mi_column_row *row));
mi_integer   MI_PROC_EXPORT mi_get_col_cacheoff ARGS((mi_column_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_col_funcid ARGS((mi_column_row *row));
mi_integer   MI_PROC_EXPORT mi_get_col_avgsize ARGS((mi_column_row *row));
mi_integer   MI_PROC_EXPORT mi_get_col_uniquevalues ARGS((mi_column_row *row));
mi_int1   MI_PROC_EXPORT mi_get_col_align ARGS((mi_column_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_col_name ARGS((mi_column_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_col_default ARGS((mi_column_row *row));
EXTERNC_END


/* in-memory representation of a row in the 'functions' table */
typedef struct mi_FunctionRow_s FunctionRow;
typedef FunctionRow mi_function_row;

/* accessor functions for mi_function_row */

EXTERNC_BEGIN
mi_oid  * MI_PROC_EXPORT mi_get_func_owner ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_schema ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_lang ARGS((mi_function_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_func_undefined ARGS((mi_function_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_func_server ARGS((mi_function_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_func_variant ARGS((mi_function_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_func_handlesnulls ARGS((mi_function_row *row));
mi_int1   MI_PROC_EXPORT mi_get_func_mode ARGS((mi_function_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_func_late ARGS((mi_function_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_func_nargs ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_rettype ARGS((mi_function_row *row));
mi_integer   MI_PROC_EXPORT mi_get_func_byte_pct ARGS((mi_function_row *row));
mi_integer   MI_PROC_EXPORT mi_get_func_perbyte_cpu ARGS((mi_function_row *row));
mi_integer   MI_PROC_EXPORT mi_get_func_percall_cpu ARGS((mi_function_row *row));
mi_integer   MI_PROC_EXPORT mi_get_func_outin_ratio ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_selec ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_negator ARGS((mi_function_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_func_isassoc ARGS((mi_function_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_func_hashable ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_commutator ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_lsortop ARGS((mi_function_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_func_rsortop ARGS((mi_function_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_func_name ARGS((mi_function_row *row));
mi_varlena  * MI_PROC_EXPORT mi_get_func_argtypes ARGS((mi_function_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_func_bin ARGS((mi_function_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_func_src ARGS((mi_function_row *row));
EXTERNC_END


/* in-memory representation of a row in the 'types' table */
typedef struct mi_TypeRow_s TypeRow;
typedef TypeRow mi_type_row;

/* accessor functions for mi_type_row */

EXTERNC_BEGIN
mi_oid  * MI_PROC_EXPORT mi_get_type_owner ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_schema ARGS((mi_type_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_type_length ARGS((mi_type_row *row));
mi_char1   MI_PROC_EXPORT mi_get_type_class ARGS((mi_type_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_type_hasdefault ARGS((mi_type_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_type_byvalue ARGS((mi_type_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_type_isdefined ARGS((mi_type_row *row));
mi_boolean   MI_PROC_EXPORT mi_get_type_canhash ARGS((mi_type_row *row));
mi_int1   MI_PROC_EXPORT mi_get_type_align ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_constructor ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_subtype ARGS((mi_type_row *row));
mi_integer   MI_PROC_EXPORT mi_get_type_bound ARGS((mi_type_row *row));
mi_integer   MI_PROC_EXPORT mi_get_type_parameter ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_input ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_output ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_receive ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_send ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_statcollect ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_statprint ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_opclass ARGS((mi_type_row *row));
mi_smallint   MI_PROC_EXPORT mi_get_type_columns ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_source ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_import ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_export ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_importbinary ARGS((mi_type_row *row));
mi_oid  * MI_PROC_EXPORT mi_get_type_exportbinary ARGS((mi_type_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_type_name ARGS((mi_type_row *row));
mi_systext  * MI_PROC_EXPORT mi_get_type_default ARGS((mi_type_row *row));
EXTERNC_END



#endif /* _MIGETCOL_H_ */

